package org.jeecg.modules.stm.best.cases.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.best.cases.entity.StBestCase;
import org.jeecg.modules.stm.best.cases.service.IStBestCaseService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
 
 
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: st_best_case
 * @Author: yzh
 * @Date:   2023-03-04
 * @Version: V1.0
 */

@RestController
@RequestMapping("/best.case/stBestCase")
@Slf4j
public class StBestCaseController extends JeecgController<StBestCase, IStBestCaseService> {
	@Autowired
	private IStBestCaseService stBestCaseService;
	
	/**
	 * 分页列表查询
	 *
	 * @param stBestCase
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "行业实践案例-分页列表查询")

	@GetMapping(value = "/list")
	public Result<IPage<StBestCase>> queryPageList(StBestCase stBestCase,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<StBestCase> queryWrapper = QueryGenerator.initQueryWrapper(stBestCase, req.getParameterMap());
		Page<StBestCase> page = new Page<StBestCase>(pageNo, pageSize);
		IPage<StBestCase> pageList = stBestCaseService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param stBestCase
	 * @return
	 */
	@AutoLog(value = "行业实践案例-添加")

	@RequiresPermissions("best.case:st_best_case:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody StBestCase stBestCase) {
		stBestCaseService.save(stBestCase);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param stBestCase
	 * @return
	 */
	@AutoLog(value = "行业实践案例-编辑")

	@RequiresPermissions("best.case:st_best_case:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody StBestCase stBestCase) {
		stBestCaseService.updateById(stBestCase);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "行业实践案例-通过id删除")

	@RequiresPermissions("best.case:st_best_case:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		stBestCaseService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "行业实践案例-批量删除")

	@RequiresPermissions("best.case:st_best_case:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.stBestCaseService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "行业实践案例-通过id查询")

	@GetMapping(value = "/queryById")
	public Result<StBestCase> queryById(@RequestParam(name="id",required=true) String id) {
		StBestCase stBestCase = stBestCaseService.getById(id);
		if(stBestCase==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(stBestCase);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param stBestCase
    */
    @RequiresPermissions("best.case:st_best_case:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, StBestCase stBestCase) {
        return super.exportXls(request, stBestCase, StBestCase.class, "st_best_case");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("best.case:st_best_case:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, StBestCase.class);
    }

}
